<ng-container *ngIf="userProfile && userPermissions">
  <div class="f-form f-form-large">
    <form [formGroup]="userForm">
      <div class="form-w-line">
        <span class="info-text" [innerHTML]="'app.main.form.info' | translate"></span>
      </div>

      <div class="form-w-line eui-u-mt-s">
        <div class="form-comp-l" euiInputGroup>
          <label euiLabel euiRequired for="userName" [innerHTML]="'app.details.user.label.userName' | translate"></label>
          <input
            euiInputText
            formControlName="userName"
            id="userName"
            placeholder="{{ 'app.details.user.label.userNamePlaceholder' | translate }}" />
          <eui-feedback-message
            *ngIf="userForm.controls.userName.touched && userForm.controls.userName.errors && userForm.controls.userName.errors['required']"
            euiDanger>
            {{ 'app.details.user.error.userNameReq' | translate }}
          </eui-feedback-message>
          <eui-feedback-message
            *ngIf="
              userForm.controls.userName.touched &&
              userForm.controls.userName.errors &&
              userForm.controls.userName.errors['DUPLICATE_USERNAME']
            "
            euiDanger>
            {{ 'app.details.user.error.userNameValid' | translate }}
          </eui-feedback-message>
          <eui-feedback-message
            *ngIf="
              userForm.controls.userName.touched && userForm.controls.userName.errors && userForm.controls.userName.errors['notUserName']
            "
            euiDanger>
            {{ 'app.details.user.error.userNamePattern' | translate }}
          </eui-feedback-message>
        </div>
      </div>

      <div class="form-w-line eui-u-mt-s">
        <div class="form-comp-l" euiInputGroup>
          <label euiLabel euiRequired for="email" [innerHTML]="'app.details.user.label.email' | translate"></label>
          <input
            euiInputText
            formControlName="email"
            id="email"
            placeholder="{{ 'app.details.user.label.emailPlaceholder' | translate }}" />
          <eui-feedback-message
            *ngIf="userForm.controls.email.touched && userForm.controls.email.errors && userForm.controls.email.errors['required']"
            euiDanger>
            {{ 'app.details.user.error.emailReq' | translate }}
          </eui-feedback-message>
          <eui-feedback-message
            *ngIf="userForm.controls.email.touched && userForm.controls.email.errors && userForm.controls.email.errors['email']"
            euiDanger>
            {{ 'app.details.user.error.emailPattern' | translate }}
          </eui-feedback-message>
          <eui-feedback-message
            *ngIf="userForm.controls.email.touched && userForm.controls.email.errors && userForm.controls.email.errors['DUPLICATE_EMAIL']"
            euiDanger>
            {{ 'app.details.user.error.duplicateEmail' | translate }}
          </eui-feedback-message>
          <eui-feedback-message
            *ngIf="userForm.controls.email.touched && userForm.controls.email.errors && userForm.controls.email.errors['INVALID_EMAIL']"
            euiDanger>
            {{ 'app.details.user.error.emailPattern' | translate }}
          </eui-feedback-message>
        </div>
      </div>

      <div class="form-w-line eui-u-mt-s" *ngIf="userForm.controls.id.value">
        <div class="form-comp-l" euiInputGroup>
          <label euiLabel euiRequired [innerHTML]="'app.details.user.label.status' | translate"></label>
          <div class="eui-u-flex">
            <eui-slide-toggle
              id="statusHelper"
              formControlName="statusHelper"
              (slideToggleChange)="slideToggleChange($event)"
              class="eui-u-mr-s"></eui-slide-toggle>
            {{ (userForm.controls.status.value ? 'app.data.user.status_1' : 'app.data.user.status_0') | translate }}
          </div>
        </div>
      </div>

      <div class="form-w-line eui-u-mt-xl">
        <div class="form-comp-l" euiInputGroup>
          <label euiLabel euiRequired for="countryHelper" #countriesComp [innerHTML]="'app.details.user.label.country' | translate"></label>
          <input *ngIf="userForm.controls.country.disabled" euiInputText formControlName="country" id="countryHelper" />
          <eui-autocomplete
            *ngIf="!userForm.controls.country.disabled"
            [class.invalid]="
              userForm.controls.countryHelper.touched &&
              userForm.controls.countryHelper.errors &&
              userForm.controls.countryHelper.errors['required']
            "
            isForceSelection
            isFreeValueAllowed="false"
            formControlName="countryHelper"
            inputId="countryHelper"
            (itemAdd)="addCountry($event)"
            (clear)="removeCountry()"
            [autocompleteData]="countries"
            placeholder="{{ 'app.details.user.label.selectCountryPlaceholder' | translate }}">
          </eui-autocomplete>
          <eui-feedback-message
            *ngIf="
              userForm.controls.countryHelper.touched &&
              userForm.controls.countryHelper.errors &&
              userForm.controls.countryHelper.errors['required']
            "
            euiDanger>
            {{ 'app.details.user.error.country' | translate }}
          </eui-feedback-message>
        </div>
      </div>

      <div class="form-w-line form-section eui-u-mt-3xl">
        <span class="header-h2">{{ 'app.details.user.section.access' | translate }}</span>
      </div>

      <div euiInputGroup *ngIf="userForm.controls.country.invalid" class="eui-u-mt-xs">
        <eui-alert isBordered>
          <span class="eui-u-pr-s">{{ 'app.manageUser.label.infoCountry' | translate }}</span>
        </eui-alert>
      </div>

      <div class="form-w-line eui-u-mt-2xl" *ngIf="userPermissions[userPermissionEnum.CRUD_USER] && userRoles?.length">
        <span class="eui-u-f-bold">{{ 'app.details.user.label.csRoleType' | translate }}</span>
      </div>
      <eui-feedback-message
        *ngIf="
          (userForm.controls.adminRoles.touched || userForm.controls.userRoles.touched) &&
          userForm.controls.roles.enabled &&
          userForm.controls.roles.errors &&
          userForm.controls.roles.errors['required']
        ">
        {{ 'app.details.user.error.csRole' | translate }}
      </eui-feedback-message>

      <div class="row eui-u-mt-xl baseline">
        <div class="col-md-6" *ngIf="userRoles?.length">
          <label euiLabel class="inputGroupLabel" [innerHTML]="'app.details.user.title.userApp' | translate"></label>
          <eui-autocomplete
            [class.invalid]="
              (userForm.controls.adminRoles.touched || userForm.controls.userRoles.touched) &&
              userForm.controls.roles.enabled &&
              userForm.controls.roles.errors &&
              userForm.controls.roles.errors['required']
            "
            isForceSelection
            isFreeValueAllowed="false"
            formControlName="userRoles"
            (itemAdd)="addRole($event, 'userRoles')"
            (itemRemove)="removeRole($event, 'userRoles')"
            [autocompleteData]="userRoles"
            placeholder="{{ 'app.details.user.label.selectRoles' | translate }}"
            [chipsPosition]="'bottom'"
            [hasChips]="true">
          </eui-autocomplete>
        </div>

        <div class="col-md-6" *ngIf="true">
          <label class="inputGroupLabel" euiLabel [innerHTML]="'app.details.user.title.csApp' | translate"></label>
          <eui-autocomplete
            [class.invalid]="
              (userForm.controls.adminRoles.touched || userForm.controls.userRoles.touched) &&
              userForm.controls.roles.enabled &&
              userForm.controls.roles.errors &&
              userForm.controls.roles.errors['required']
            "
            isForceSelection
            isFreeValueAllowed="false"
            formControlName="adminRoles"
            inputId="adminRoles"
            (itemAdd)="addRole($event, 'adminRoles')"
            (itemRemove)="removeRole($event, 'adminRoles')"
            [autocompleteData]="adminRoles"
            placeholder="{{ 'app.details.user.label.selectRoles' | translate }}"
            [chipsPosition]="'bottom'"
            [hasChips]="true">
          </eui-autocomplete>
        </div>
      </div>

      <div class="form-w-line eui-u-mt-2xl" *ngIf="userPermissions[userPermissionEnum.CRUD_USER]">
        <span class="eui-u-f-bold">{{ 'app.details.user.title.activePeriod' | translate }}</span>
      </div>

      <div class="form-w-line eui-u-mt-xl row">
        <div class="col-md-6" euiInputGroup>
          <label euiLabel euiRequired>{{ 'app.manageUser.label.startDate' | translate }}</label>
          <eui-datepicker formControlName="startDate" placeholder="MM/DD/YYYY" [minDate]="minDate"></eui-datepicker>
          <eui-feedback-message
            *ngIf="
              userForm.controls.startDate.touched && userForm.controls.startDate.errors && userForm.controls.startDate.errors['required']
            "
            euiDanger>
            {{ 'app.details.user.error.startDateReq' | translate }}
          </eui-feedback-message>
        </div>
        <div class="col-md-6" euiInputGroup>
          <label euiLabel euiRequired>{{ 'app.manageUser.label.endDate' | translate }}</label>
          <eui-datepicker
            formControlName="endDate"
            placeholder="MM/DD/YYYY"
            [maxDate]="maxDate"
            [minDate]="userForm.controls.startDate.disabled ? minDate : userForm.controls.startDate.value"></eui-datepicker>
          <eui-feedback-message
            *ngIf="userForm.controls.endDate.touched && userForm.controls.endDate.errors && userForm.controls.endDate.errors['required']"
            euiDanger>
            {{ 'app.details.user.error.endDateReq' | translate }}
          </eui-feedback-message>
        </div>
      </div>
    </form>
  </div>
</ng-container>

<app-confirmation-dialog
  #confirmationDialog
  [config]="confirmationDialogConfig"
  [translations]="confirmationDialogTranslations"
  (accept)="saveUserData()">
  <app-user-edit-confirmation
    *ngIf="userForm"
    [userData]="userForm.getRawValue()"
    [initialUserData]="initialUserData"
    [valid]="userForm.valid" />
</app-confirmation-dialog>
